#
# HRM Install Checker Copyright Fujitsu Limited 2007
# All Right Reserved
# $Revision: 1.13 $
#

nr_err=0		# total number of errors
nr_warn=0		# total number of warnings
nr_ok=0			# total number of OKs 
nr_items=0		# total number of test items
indent="  "		# indent of each items

#
# initialize the variables to display items
#
init()
{
	str1=""
	str2=""
	str3=""
}

#
# show the item line
# Usage: title "label" "value"
#
title()
{
	line="............................................"
        n=`expr "$1" : ".*"`
	echo $echo_opt "$indent $1" `echo $line |cut -c$n-` "\c"

	is_err=0
	is_warn=0
	for s in "$str1" "$str2" "$str3"
	do
		if expr "$s" : "E" >/dev/null
		then
			is_err=1
		fi
		if expr "$s" : "W" >/dev/null
		then
			is_warn=1
		fi
	done

	if [ $is_err -ne 0 ]
	then
		r="*NG"
		nr_err=`expr $nr_err + 1`

	elif [ $is_warn -ne 0 ]
	then
		r="*WARN"
		nr_warn=`expr $nr_warn + 1`
	else
		r=" OK"
		nr_ok=`expr $nr_ok + 1`
	fi
	nr_items=`expr $nr_items + 1`

	shift
	echo $echo_opt "$r\c"
	if [ "$1" != "" ]
	then
		echo "($*)"
	else
		echo ""
	fi

	for s in "$str1" "$str2" "$str3"
	do
		if [ "$s" != "" ]
		then
			s=`echo "$s" | /bin/sed "s/^[EWI][0-9][0-9][0-9][0-9]/&${modelcode}/"`
			echo $echo_opt "$s" | /bin/sed "s/^/      /"; echo ""
		fi
	done

}


end()
{
	echo "$title09"
	echo "Total:$nr_items OK:$nr_ok NG:$nr_err Warning:$nr_warn"

	echo ""
	if [ "$nr_err" -eq 0 -a "$nr_warn" -eq 0 ]
	then
		printf "$result_01"
	fi
	if [ "$nr_err" -gt 0 ]
	then
		printf "$result_02" "$nr_err"
	fi
	if [ "$nr_warn" -gt 0 ]
	then
		printf "$result_03" "$nr_warn"
	fi
	echo ""
	exit 0
}



# input: query_prompt
# output: ans (=y or n)
query_yorn()
{
	while :
	do
	        echo $echo_opt "$query_prompt" "[y,n] \c"
		read ans
	        if [ "$ans" = "y" -o "$ans" = "Y" -o "$ans" = "yes" -o "$ans" = "YES" ]
        	then
			ans="y"
			break
	        fi
	        if [ "$ans" = "n" -o "$ans" = "N" -o "$ans" = "no" -o "$ans" = "NO" ]
		then
                	ans="n"
			break
		fi
		echo ""
	done
}

sect=1
section()
{
	echo "$sect. $*"
	sect=`expr $sect + 1`
}


#------------------------------------------------------------
#
# determine the message file
#
msgtmp="/tmp/hrm_install_msg_temp.$$"
base=`echo "$0" | /bin/sed "s/\.sh$/\.msg/"`
jcode=`expr "$LANG" : 'ja_JP.\(.*\)'`	   # ja_JP.XXXXX
if [ $? = 0 ]
then
	/usr/bin/iconv -f EUC-JP -t "$jcode" ${base}.ja > $msgtmp
	if [ $? != 0 ]
	then
		echo "ERROR: failed to convert the message file to $jcode"
		/bin/rm -f "$msgtmp"
		exit 1
	fi
	msgfile="$msgtmp"

elif [ -f "${base}.${LANG}" ]
then
	msgfile="${base}.${LANG}"
else
	msgfile="${base}"
fi

. $msgfile				# read message

if [ $? != 0 ] ; then
	echo "ERROR: message file ($msgfile) failed to read."
	if [ -f "$msgtmp" ]; then /bin/rm -f "$msgtmp"; fi
	exit 1
fi



#------------------------------------------------------------
# bash(linux) check
if [ "$BASH_VERSION" != "" ]
then
	echo_opt="-e"
fi
#------------------------------------------------------------
# run as wrapper 

if [ "$1" != "main_running" ]
then
        outfile="/tmp/hrm_check_result_"`/bin/date "+%Y%m%d_%H%M%S"`
        /bin/sh $0 main_running 2>&1 | tee "$outfile"

        #
        # save result
        #
        query_prompt=`printf "$prompt_02" "$outfile"`
        query_yorn
        if [ "$ans" = "y" ]
        then
		echo "$prompt_03"
        else
                /bin/rm -f "$outfile"
        fi

	#
	# finish 
	#
	if [ -f "$msgtmp" ]; then /bin/rm -f "$msgtmp"; fi
        exit 0
fi
if [ -f "$msgtmp" ]; then /bin/rm -f "$msgtmp"; fi


#------------------------------------------------------------
# initialize
#
LC_ALL=C export LC_ALL
num=1
hrmpkg="FJSVhrm"		# use below

