#!/bin/sh -xv
#
# HRM hrmsnap for PRIMEQUEST/Linux Copyright Fujitsu Limited 2006-2007
# All Right Reserved
# $Id: hrmsnap_main.sh,v 1.6 2008/03/21 06:54:36 ishihara Exp $
#

#
# Locking ( Lock at 10Sec Over Then Unlock )
#
do_lock()
{
	n=1
        until /bin/ln -s /dev/null $lockfile 2>/dev/null 
        do
                sleep 1
                if [ $n -gt 10 ] ; then break; fi	# max 10 sec
                n=`expr $n + 1`
        done
}

do_unlock()
{
        rm $lockfile
}

progress()
{
        do_lock
        echo "$1 $2" > $snapdir/.snap_progress
        do_unlock
}

#
# iniե˵Ҥ줿ĶѿŸ 2007.08.22 M.Ochiai
#
ini_env2path(){

    while read FL
    do
        t=`expr "$FL" : ".*%\(.*\)%"`
        if [ "$t" != "" ]
        then
            prev=`expr "$FL" : "\(.*\)%${t}%"`
            aftr=`expr "$FL" : ".*%${t}%\(.*\)"`
            if [ "$prev" != "" -a "$aftr" != "" ]
            then
                eval "v=\$$t"
                FL="$prev$v$aftr"
            fi
        fi
        echo $FL

    done < $HRM_config/collector_snap.ini
}

#
# check hard,soft,hrm flag
#
is_hard=0
is_soft=0
is_hrm=0
is_remcs=0
while [ "$1" != "" ]
do
        if [ "$1" = "hard" ];then  is_hard=1; fi
        if [ "$1" = "soft" ];then  is_soft=1; fi
        if [ "$1" = "hrm" ];then  is_hrm=1; fi
        if [ "$1" = "remcs" ];then  is_remcs=1; fi
        shift
done

# if none of them specified, enable all flags
if [ $is_hard = 0 -a $is_soft = 0 -a $is_hrm = 0 ]; then
        is_hard=1
        is_soft=1
        is_hrm=1
fi

progress 1 100 # Parameter Changed 2007.08.22 M.Ochiai
echo "HRMsnap start " `/bin/date '+%D %T'`
echo "model=$HRM_model"

#
# (*)collectorƤӽФ֥ե 2007.08.22 M.Ochiai
#
if [ "$is_hard" = 1 ];then
    ini_env2path > $HRM_temp/collector_snap.ini

    $HRM_bin/collector -i $HRM_temp/collector_snap.ini
    if [ $? != 0 ]
    then
        echo "Hrmsnap collector failed."
    fi

fi

progress 2 100
#
# (*)OfflineData 2007.08.22 M.Ochiai
#
if [ "$is_hrm" = 1 ];then
    $HRM_bin/snap_hrmsnap.sh snap
fi

#
# HRM Prognosis output CSV
#

progress 51 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# prognosis statlist
#
if [ "$is_hard" = 1 ];then
	$HRM_bin/prognosis statlist > $HRM_temp/statlist.$$

	#
	#statlist line(=prignosis device count)
	#

	fileline=`wc -l $HRM_temp/statlist.$$`

	progress 52 100 # Parameter Changed 2007.08.22 M.Ochiai

	c=1
	while [ "$c" -le "$fileline" ]
	do
		hminame=`sed -n ${c}p $HRM_temp/statlist.$$ | cut -f1 -d\;`
		devname=`grep "$hminame" $HRM_config/conv_devlist_tbl | cut -f1 -d\;`
		for location in `sed -n ${c}p $HRM_temp/statlist.$$ | sed -e "s/$hminame;//"`
		do
			location=`echo $location | sed 's/^I....://'`
			slash_ascii=`echo $location | sed 's/\//%2f/g'`
			filename="statshow_$devname_$slash_ascii"
			#prognosis statshow
			$HRM_bin/prognosis statshow $devname $location > $progshowdir/$filename
		done
		c=`expr $c + 1`
	done
	rm -rf "$HRM_temp/statlist.$$"
fi

#
# OS Infomation
#

progress 55 100 # Parameter Changed 2007.08.22 M.Ochiai

if [ "$is_hard" = 1 ] ; then
	/bin/ps -elf > $tempdir/ps-elf                      2>&1
	cat /etc/syslog.conf > $tempdir/etc_syslog.conf     2>&1
	cat /etc/services > $tempdir/etc_services           2>&1
	cat /etc/snmp/snmpd.conf > $tempdir/etc_snmp_snmpd.conf 2>&1
	/usr/bin/who -rb > $tempdir/who_rb    2>&1
	/sbin/lsmod       > $tempdir/lsmod    2>&1
	/sbin/lspci -vv   > $tempdir/lspci-vv 2>&1
	/bin/uname -a     > $tempdir/uname-a  2>&1
	/bin/df           > $tempdir/df    2>&1
	/bin/df -k        > $tempdir/df-k  2>&1
fi

progress 57 100

if [ "$is_hard" = 1 ] ; then
        cat /proc/cpuinfo > $tempdir/proc_cpuinfo 2>&1
        cat /proc/meminfo > $tempdir/proc_meminfo 2>&1
        cat /proc/cmdline > $tempdir/proc_cmdline 2>&1
        cat /proc/scsi/scsi > $tempdir/proc_scsi_scsi 2>&1
        cat /etc/redhat-release > $tempdir/etc_redhat-release 2>&1
fi

progress 58 100

if [ "$is_hard" = 1 ] ; then
        /bin/netstat -an >  $tempdir/netstat-an 2>&1
fi

progress 59 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# Network Setting
#

if [ "$is_hard" = 1 ] ; then
	/sbin/ifconfig -a  > $tempdir/ifconfig_a
fi

progress 60 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# HRM Module Version
#

$HRM_bin/version.sh all > $tempdir/hrm_versions

if [ "$is_soft" = 1 ] ; then
	/bin/rpm -qai > $tempdir/rpm-qai
fi

progress 75 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# Path Change First '/' (is not applied to PQ-Linux?)
#

if [ "$is_hard" = 1 ] ; then
	HRM_data_dir=`echo $HRM_data | cut -c2-`
	SSC_log="var/opt/FJSVhrmst/log/"
fi
if [ "$is_hrm" = 1 ] ; then
	HRM_update_dir=`echo $HRM_update | cut -c2-`
	HRM_config_dir=`echo $HRM_config | cut -c2-`
	HRM_log_dir=`echo $HRM_log | cut -c2-`
fi
HRM_temp_dir=`echo $tempdir | cut -c2-`

progress 77 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# HRM Program Infomation
#
if [ "$is_hrm" = 1 ] ; then
	/bin/ls -l $HRM_bin  > $tempdir/HRM_bin_list
	/bin/ls -l $HRM_temp > $tempdir/HRM_temp_list
fi

progress 80 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# PQ Log Get ( getopsa command call )
#
# /opt/FJSVpsa/sh/getopsa $tempdir/getopsa_log 2>/dev/null

progress 83 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# ServerViewRaid log
#
if [ -d /opt/fujitsu/ServerViewSuite/RAIDManager/web/public/ ]; then
    cp -p /opt/fujitsu/ServerViewSuite/RAIDManager/web/public/RAIDLog.xml $tempdir
    cp -p /opt/fujitsu/ServerViewSuite/RAIDManager/web/public/RAIDLog1.xml $tempdir
fi

progress 85 100

#
# SLCA Archive
#
#	${HRM_bin}/slca afr $snapdir/$snapfile  \
#		$HRM_temp_dir $HRM_data_dir $HRM_config_dir $HRM_update_dir \
#		$HRM_log_dir \
#		var/log/messages* \ 
#		var/log/hwsp \
#		var/opt/FJSVpsa/log var/opt/FJSVpsa/sellog var/opt/FJSVpsa/sallog \
#		var/opt/FJSVpsa/trc

cd /
if [ "$is_hard" = 1 -o "$is_soft" = 1 ]
then
	/bin/dmesg > $tempdir/dmesg
        msg=`echo var/log/messages*`
else
        msg=""
fi

if [ "$is_hard" = 1 ]
then
        psalog="var/log/hwsp var/opt/FJSVpsa/log var/opt/FJSVpsa/sellog var/opt/FJSVpsa/sallog var/opt/FJSVpsa/trc"
else
        psalog=""
fi



#
# create an archive in the slca or tar or zip format
#
cd /
if [ "$snap_ext" = "slc" ]
then

	${HRM_bin}/slca afr $snapdir/$snapfile  \
		$HRM_temp_dir $HRM_data_dir $HRM_config_dir $HRM_update_dir \
		$HRM_log_dir $SSC_log \
		$msg $psalog

elif [ "$snap_ext" = "tgz" ]
then

	/bin/tar -czvf $snapdir/$snapfile  \
		$HRM_temp_dir $HRM_data_dir $HRM_config_dir $HRM_update_dir \
		$HRM_log_dir $SSC_log \
		$msg $psalog

elif [ "$snap_ext" = "zip" ]
then

	${HRM_bin}/hrmzip -r $snapdir/$snapfile  \
		$HRM_temp_dir $HRM_data_dir $HRM_config_dir $HRM_update_dir \
		$HRM_log_dir $SSC_log \
		$msg $psalog
        cd $HRM_temp/snapwork
        ${HRM_bin}/hrmzip -r $snapdir/$snapfile  \
                customers hosts
        cd ..

else
	$HRM_bin/hrmevent "E0900:invalid archive format($snap_ext)"
fi


progress 90 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# set file size into begin line
#

size=`wc -c < $snapdir/$snapfile`
$HRM_bin/uuencode $snapdir/$snapfile $size > $snapdir/${snapfile}.uue
mv $snapdir/${snapfile}.uue $snapdir/$snapfile

lines=`wc -l < $snapdir/${snapfile}`
echo "$snapfile $lines $size" > $snapdir/.snap_result

progress 95 100 # Parameter Changed 2007.08.22 M.Ochiai

#
# remove all temporary file
#
rm -rf $HRM_temp/hrmsnap_temp/*
rm -f $snapdir/.snap_pid
#
# 2007.08.22 M.Ochiai
#
rm -rf $HRM_temp/snapwork/customers
rm -rf $HRM_temp/snapwork/hosts

progress 100 100 # Parameter Changed 2007.08.22 M.Ochiai

echo "HRMsnap end " `/bin/date '+%D %T'`

if [ "$is_remcs" != "1" ]
then
	$HRM_bin/hrmevent "I0915:snap is finished."
fi

exit 0
