#!/usr/bin/perl
use strict;

$|=1;

use vars qw($syslog_ip $syslog_trans);
use vars qw($resource_ip $resource_mem $resource_trans);
use vars qw($key);
use vars qw($resource_list $resource_time $sdb_renkei);
use vars qw(%cycles %mem_types);
use vars qw($sdb_ip $sdb_port $send_cycle);
use vars qw($sdb_mount_point $sdb_mem_flg $sdb_samplecnt $sdb_send_cycle);
use vars qw($has_changed);

use vars qw($msg01 $msg02 $msg03 $msg04 $msg05 $msg06 $msg07);
use vars qw($msg11 $msg12 $msg13 $msg14 $msg15 $msg16 $msg17 $msg18);
use vars qw($msg20 $msg21 $msg22 $msg23 $msg24 $msg25 $msg26 $msg27 $msg28);
use vars qw($msg30 $msg31 $msg32 $msg33 $msg34 $msg35 $msg36 $msg37);
use vars qw($msg40 $msg41 $msg42 $msg43 $msg44 $msg45 $msg46 $msg47 $msg48 $msg49);
use vars qw($msg50 $msg51 $msg52 $msg53 $msg54 $msg55 $msg56 $msg57 $msg58);
use vars qw($msg60 $msg61 $msg62 $msg63 $msg64);
use vars qw($msg70 $msg71 $msg72 $msg73 $msg74 $msg75 $msg76 $msg77 $msg78);
use vars qw($msg80 $msg81 $msg82 $msg83 $msg84 $msg85 $msg86 $msg87);
use vars qw($msg90 $msg91 $msg92 $msg93 $msg94);

#
# start of messages (English)
# 

$msg01="enable";
$msg02="disable";
$msg03="unknown";
$msg04="error";
$msg05="physical memory + virtual memory";
$msg06="physical memory";
$msg07="none";

$msg11="1    enable and set up the forwarding resource";
$msg12="2    disable the forwarding resource";
$msg13="3    apply old SDB agent setting";
$msg14="4    forwarding syslog test";
$msg15="5    forwarding resource test";
$msg16="6    change the setting of logging for SDB";
$msg17="q    quit";
$msg18="Select a number (1-6,q):";

$msg20="===== SDB Agent Setting =====";
$msg21="current status:";
$msg22="forwarding syslog";
$msg23="forwarding resource";
$msg24="forwarding cycle";
$msg25="mount point";
$msg26="memory report";
$msg27="Logging for SDB";
$msg28=" + ";			# indent

$msg30="Enter IP address of SDB(XXX.XXX.XXX.XXX) [q:quit]: ";
$msg31="Select cycle of the forwarding resource.";
$msg32="  q  cancel";
$msg33="  Select (default: 60 minutes): ";
$msg34="Enter mount points (except / directory) seprated by a space.";
$msg35="available mount points:";
$msg36="Enter(q:cancel) : ";
$msg37="Select memory report type.";

$msg40="IP address       :";
$msg41="Forwarding cycle :";
$msg42="Mount points     :";
$msg43="Memory report    :";
$msg44="Apply above setting? ";
$msg45="ERROR: failed to set up IP address.";
$msg46="ERROR: failed to set up forwarding cycle.";
$msg47="WARNING: failed to remove %s from mount point list.\n";
$msg48="WARNING: failed to add %s to mount point list.\n";
$msg49="finished.";
$msg50="Disable the forwarding resource?";
$msg51="Successfully disabled.";
$msg52="ERROR: failed to disable the forwarding resource.";
$msg53="Send a test data of forwarding syslog?";
$msg54="Successfully sent. Confirm the sent data was appeared on the SDB monitor.";
$msg55="ERROR: failed to send test data.";
$msg56="Send a test data of forwarding resource?";
$msg57="Successfully sent.";
$msg58="ERROR: failed to send test data.";

$msg60="Logging for SDB is enabled. Change to be disabled?";
$msg61="Logging for SDB is disabled. Change to be enabled?";
$msg62="Logging for SDB is enabled.";
$msg63="Logging for SDB is disabled.";
$msg64="An errror occurred while changing the Logging for SDB setting.";

$msg70="every 3 minutes";
$msg71="every 5 minutes";
$msg72="every 10 minutes";
$msg73="every 15 minutes";
$msg74="every 20 minutes";
$msg75="every 30 minutes";
$msg76="every 60 minutes";
$msg77="Transmitting. Please wait for a while.";
$msg78="To reflect the changes of SDB setting, please restart HRM/server.";

$msg80="This is not available because syslog forwarding is disabled.";
$msg81="This is not available because resource forwarding is disabled.";
$msg82="ERROR: old SDB agent is not installed.";
$msg83="ERROR: one or more mount points must be specified.";
$msg84="ERROR: failed to set up memory report.";
$msg85="ERROR: failed to set up resource forwarding port.";
$msg86="ERROR: Invalid IP address format.";
$msg87="ERROR: Each octet of IP address should not have leading zeros.\n"
     . "       e.g.: 010.001.000.100  error\n"
     . "                  10.1.0.100  okay\n";

$msg90="The settings of old SDB agent is as follows.";
$msg91="Apply above settings? ";
$msg92="port";
$msg93="  Note:the cycle becomes 3600 seconds (60 minutes) when applied.\n";
$msg94="seconds";

#
# end of messages
#

my $sdb_timer_ini = "/opt/sdb/etc/sdb_timer.ini";
my $sdb_medicp_ini = "/opt/sdb/etc/sdb_medicp.ini";
my $sdb_ini       = "/var/opt/FJSVhrm/config/sdb_set.ini";


$ENV{"HRM_bin"}    = "/opt/FJSVhrm/bin";
$ENV{"HRM_update"} = "/opt/FJSVhrm/update";
$ENV{"HRM_config"} = "/var/opt/FJSVhrm/config";
$ENV{"HRM_temp"}   = "/var/opt/FJSVhrm/temp";
$ENV{"HRM_log"}    = "/var/opt/FJSVhrm/log";
$ENV{"HRM_data"}   = "/var/opt/FJSVhrm/data";

#
# dummy call of sdb command to set up disk list
#
system "$ENV{HRM_bin}/sdb resource list >/dev/null";
$has_changed = 0;

#
# load messages
#	$HRM_bin/sdbsetup.msg.utf8
#	$HRM_bin/sdbsetup.msg.eucJP
#
my $base_sdb = $ENV{"HRM_bin"};
if( defined($ARGV[0]) && $ARGV[0] eq "-j" )
{
	if($ARGV[1]  eq "utf8" && -f "$base_sdb/sdbsetup.msg.utf8" )
	{
		do "$base_sdb/sdbsetup.msg.utf8";
	}
	elsif($ARGV[1] eq "euc" && -f "$base_sdb/sdbsetup.msg.eucJP" )
	{
		do "$base_sdb/sdbsetup.msg.eucJP";
	}else
	{
		print "usage: sdbsetup.pl -e | -j euc | -j utf8\n";
		exit(1);
	}
}elsif( defined($ARGV[0]) && $ARGV[0] eq "-e" )
{
	;
}else
{
	if($ENV{"LANG"} eq "ja_JP.UTF-8" && -f "$base_sdb/sdbsetup.msg.utf8" )
	{
		do "$base_sdb/sdbsetup.msg.utf8";
	}
	elsif($ENV{"LANG"} eq "ja_JP.eucJP" && -f "$base_sdb/sdbsetup.msg.eucJP" )
	{
		do "$base_sdb/sdbsetup.msg.eucJP";
	}else
	{
		;
	}
}


#
# Usage: input_yorn("prompt")
#     return 1 if "y" 
#            0 if "n"
sub input_yorn()
{
	my($prompt_str) = @_;
	while(1)
	{
		print "$prompt_str [y/n]: ";
		$key=<STDIN>;
		chomp($key);
		return 1 if( $key eq "y");
		return 0 if( $key eq "n");
	}
}

sub press_enter()
{
	print "[press enter]";
	$key=<STDIN>;
}


#
# Get syslog settings
#
sub check_syslog
{
	$syslog_ip = $msg03;
	$syslog_trans = `/opt/FJSVhrm/bin/sdb syslog ip | /usr/bin/head -1`;
	chomp($syslog_trans);

	if($syslog_trans eq "enabled")
	{
		$syslog_ip = `/opt/FJSVhrm/bin/sdb syslog ip | /bin/sed -n 2p`;
		chomp($syslog_ip);
	}
}

#
# Get resource settings.
#
sub check_resource
{
	$resource_ip = $msg03;
	$resource_mem = "";
	$resource_trans = `/opt/FJSVhrm/bin/sdb resource ip | /usr/bin/head -1`;
	chomp($resource_trans);

	if($resource_trans eq "enabled")
	{
		$resource_ip = `/opt/FJSVhrm/bin/sdb resource ip | /bin/sed -n 2p`;
		chomp($resource_ip);
	}	

		my $disk_list="";
		open(F, "/opt/FJSVhrm/bin/sdb resource list |") || return;
		while(<F>)
		{
			my @data;
			chomp;
			@data = split(/\s+/, $_);
			if( $data[0] =~ s/^disk\.// )
			{
				if($data[1] eq "on"){ $disk_list .= "$data[0] "; }
			}

			if( $data[0] eq "memory" && $data[1] eq "on" )
			{
				$resource_mem .= "P";
			}
			if( $data[0] eq "memory_virtual" && $data[1] eq "on" )
			{
				$resource_mem .= "V";
			}
		}
		close(F);
		$resource_list=$disk_list;
		$resource_time=`/opt/FJSVhrm/bin/hrmenv list | /bin/grep '^period/sdbresource'`;
		chomp($resource_time);
}

#
# Get SDB renkei settings
#
sub check_sdb_renkei
{
	open(F, "$ENV{HRM_config}/common.ini") || die "common.ini not found.\n";
	while(<F>)
	{
		if(/^enable\s*=\s*1/)
		{
			$sdb_renkei=1;
			close(F);
			return;
		}
	}
	close(F);
	$sdb_renkei=0;
}


#
# title diplay 
#
sub title
{
	print "\n";
	print "$msg20\n\n";
	print "$msg21\n";

	if($syslog_trans eq "disabled")
	{
		printf "  %-26s%s\n", $msg22, $msg02;
	}else
	{
		printf "  %-26s%s\n", $msg22, $syslog_ip;
	}

	if($resource_trans eq "disabled")
	{
		printf "  %-26s%s\n", $msg23, $msg02;
	}else
	{
		%cycles = (
                "period/sdbresource=*/3_*_*_*_*" =>"$msg70",
                "period/sdbresource=*/5_*_*_*_*" =>"$msg71",
                "period/sdbresource=*/10_*_*_*_*" =>"$msg72",
                "period/sdbresource=*/15_*_*_*_*" =>"$msg73",
                "period/sdbresource=*/20_*_*_*_*" =>"$msg74",
                "period/sdbresource=*/30_*_*_*_*" =>"$msg75",
                "period/sdbresource=0_*_*_*_*"    =>"$msg76",
                "period/sdbresource=0_*/1_*_*_*" =>"$msg76",
		);

		%mem_types = (
		"P"	=> "$msg06",
		"PV"	=> "$msg05",
		"VP"	=> "$msg05",
		);

		printf "  %-26s%s\n", $msg23, $resource_ip;
		printf "  %-26s%s\n", $msg28.$msg24, $cycles{$resource_time};
		printf "  %-26s%s\n", $msg28.$msg25, "/ " . $resource_list;
		printf "  %-26s%s\n", $msg28.$msg26, $mem_types{$resource_mem};
	}

	if($sdb_renkei == 1)
	{
		printf "  %-26s%s\n", $msg27, $msg01;
	}else
	{
		printf "  %-26s%s\n", $msg27, $msg02;
	}

	print "\n";
	print "$msg11\n";
	print "$msg12\n";
	print "$msg13\n";
	print "$msg14\n";
	print "$msg15\n";
	print "$msg16\n";
	print "$msg17\n";
	print "\n";
	print "$msg18";
}



#
# resource to be enabled 
#
sub change_resource_setting
{
	my ($addr, $c, $msg, $cycle, $cycle_str, $all_point, @data);
	my ($mount_point, $memtype, $memtype_str);

	print "\n";
	print "$msg30";
	$addr = <STDIN>;
	chomp($addr);
	return if($addr eq 'q');

	if($addr =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)
	{
		my $octet1=$1;
		my $octet2=$2;
		my $octet3=$3;
		my $octet4=$4;

		if($octet1 >= 1 && $octet1 <= 223 &&
                   $octet2 >= 0 && $octet2 <= 255 &&
                   $octet3 >= 0 && $octet3 <= 255 &&
                   $octet4 >= 1 && $octet4 <= 254)
		{
			;	# OK
		}else
		{
			print "$msg86\n";
			return;
		}

		if($octet1 =~ /^0\d/ || $octet2 =~ /^0\d/ ||
                   $octet3 =~ /^0\d/ || $octet4 =~ /^0\d/ )
		{
			print "$msg87\n";
			return;
		}

	}else
	{
		print "$msg86\n";
		return;
	}

	print "\n";
	print "$msg31\n";		# data transfer cycle
	$c = 1;
	foreach $msg ( $msg70, $msg71, $msg72, $msg73, $msg74, $msg75, $msg76 )
	{
		print "  $c  $msg\n";
		$c++;
	}
	print "$msg32\n\n";		# cancel
	print "$msg33";
	$key = <STDIN>;
	chomp($key);
	return if($key eq "q");	


	$cycle="";
	if($key eq ""){ $key = "7"; }	# default 60 min
	if($key == 1){ $cycle="*/3_*_*_*_*";  $cycle_str=$msg70; }
	if($key == 2){ $cycle="*/5_*_*_*_*";  $cycle_str=$msg71; }
	if($key == 3){ $cycle="*/10_*_*_*_*"; $cycle_str=$msg72; }
	if($key == 4){ $cycle="*/15_*_*_*_*"; $cycle_str=$msg73; }
	if($key == 5){ $cycle="*/20_*_*_*_*"; $cycle_str=$msg74; }
	if($key == 6){ $cycle="*/30_*_*_*_*"; $cycle_str=$msg75; }
	if($key == 7){ $cycle="0_*_*_*_*";    $cycle_str=$msg76; }

	if($cycle eq ""){
		print "input error\n";
		return;
	}

	print "\n";
	print "$msg34\n";

	$all_point="";
	open(F, "$ENV{HRM_bin}/sdb resource list |") || die;
	while(<F>)
	{
		chomp;
		if( s/^disk\.// )
		{
			@data = split(/\s+/);
			if( $data[1] eq "on" || $data[1] eq "off" )
			{
				$all_point .= " $data[0]";
			}
		}
	}
	close(F);
				
        print "$msg35","$all_point","\n";
        print "$msg36";
        $mount_point = <STDIN>;
	chomp($mount_point);
	return if($mount_point eq "q" );
	#if($mount_point =~ /^\s*$/ )		# allow mount point is nothing
	#{
	#	print "$msg83\n";
	#	return;
	#}

	print "\n";				# memory
	print "$msg37\n";
	print "  1   $msg05\n";
	print "  2   $msg06\n";
	print "$msg36";
	$memtype=<STDIN>;
	chomp($memtype);
	return if($memtype eq "q");
	$memtype_str="";
	if($memtype == 1 ){ $memtype_str=$msg05; }
	if($memtype == 2 ){ $memtype_str=$msg06; }
	if($memtype_str eq "")
	{
		print "input error\n";
		return;
	}


	print "\n";
	print "$msg40 ", $addr,        "\n";
	print "$msg41 ", $cycle_str,   "\n";
	print "$msg42 ", $mount_point, "\n";
	print "$msg43 ", $memtype_str, "\n";

	if(&input_yorn($msg44))
	{
		my $r;
		my $m;
		$r = system "$ENV{HRM_bin}/sdb resource enable $addr";
		if($r != 0)
		{
			print "$msg45\n";	# failed to set IP address
			return;
		}

		$r = system "$ENV{HRM_bin}/hrmenv set period/sdbresource=$cycle";
		if($r != 0)
		{
			print "$msg46\n";	# failed to set cycle
			return;
		}

		foreach $m ( split(/\s+/, $resource_list ))	# current settings
		{
			next if $m eq "";
			$r = system "$ENV{HRM_bin}/sdb resource set disk.$m off";
			if($r != 0)
			{
				printf "$msg47", $m;
			}
		}

		foreach $m ( split(/\s+/, $mount_point ))	# to be set
		{
			next if $m eq "";
			$r = system "$ENV{HRM_bin}/sdb resource set disk.$m on";
			if($r != 0)
			{
				printf "$msg48", $m;
			}
		}
		if($memtype == 1)				# phy + vir
		{
			$r = system "$ENV{HRM_bin}/sdb resource set memory on";
			$r |= system "$ENV{HRM_bin}/sdb resource set memory_virtual on";
			if($r != 0)
			{
				printf "$msg84\n";
			}
		}elsif($memtype == 2)				# phy
		{
			$r = system "$ENV{HRM_bin}/sdb resource set memory on";
			$r |= system "$ENV{HRM_bin}/sdb resource set memory_virtual off";
			if($r != 0)
			{
				printf "$msg84\n";
			}
		}

		print "$msg49\n";
		$has_changed = 1;
	}
}


#
# resource to be disabled
#
sub disable_resource_setting
{
	if(&input_yorn($msg50))
	{
		my $r;
		$r = system "$ENV{HRM_bin}/sdb resource disable";
		if($r == 0)
		{
			print "$msg51\n";
			$has_changed = 1;
		}else
		{
			print "$msg52\n";
		}
	}
}
	
#
# send test data using syslog transfer
#	
sub send_syslog_test_data
{
	if($syslog_trans eq "disabled")
	{
		print "$msg80\n";
		return;
	}

	if(&input_yorn($msg53))
	{
		my $r;
		print "$msg77\n";
		$r = system "$ENV{HRM_bin}/sdb syslog test";
		if($r == 0)
		{
			print "$msg54\n";
		}else
		{
			print "$msg55\n";
		}
	}
}

	
#
# send test data using resource transfer
#	
sub send_resource_test_data
{
	if($resource_trans eq "disabled")
	{
		print "$msg81\n";
		return;
	}

	if(&input_yorn($msg56))
	{
		my $r;
		print "$msg77\n";
		$r = system "$ENV{HRM_bin}/sdb resource test";
		if($r == 0)
		{
			print "$msg57\n";
		}else
		{
			print "$msg58\n";
		}
	}
}


#
# sdb renkei setting
#
sub change_sdb_renkei
{
	my($r) = -2;
	my $mes;
	print "\n";
	if($sdb_renkei == 0)		# currently disabled
	{
		if(&input_yorn($msg61))	
		{
			$r = system "/bin/sed 's/^enable *= *0/enable=1/' $ENV{HRM_config}/common.ini > $ENV{HRM_temp}/commonini.$$";
			$mes = "$msg62";
		}
	}else
	{
		if(&input_yorn($msg60))
		{
			$r = system "/bin/sed 's/^enable *= *1/enable=0/' $ENV{HRM_config}/common.ini > $ENV{HRM_temp}/commonini.$$";
			$mes = "$msg63";
		}
	}

	return if($r == -2);
	if($r == 0 && -f "$ENV{HRM_temp}/commonini.$$")
	{
		$r = system "/bin/cp -p $ENV{HRM_temp}/commonini.$$ $ENV{HRM_config}/common.ini";
		if($r == 0)
		{
			unlink "$ENV{HRM_temp}/commonini.$$";
			print "$mes\n";
			return;
		}
	}

	unlink "$ENV{HRM_temp}/commonini.$$";
	print "$msg64\n";
}
	

#
# SDB convertion from sabi to HRM
#

sub conv_check
{
	my $ini;
	foreach $ini ( $sdb_timer_ini, $sdb_medicp_ini )
	{
		if(! -f "$ini")
		{
			print "$msg82\n";
			return 1;
		}
	}
	if( ! -f  $sdb_ini )
	{
		print "ERROR: $sdb_ini not found.\n";
		return 1;
	}
	return 0;
}

sub conv_read_timer
{
	$sdb_ip="";
	$sdb_port="";
	$send_cycle="";
	open(F, $sdb_timer_ini) || die;
	while(<F>){
		if(m|^/opt/sdb/sbin/sdb_medicp (\d+\.\d+\.\d+\.\d+):(\d+),(\d+),|)
		{
			$sdb_ip=$1;
			$sdb_port=$2;
			$send_cycle=$3;
			last;
		}
	}	
	close(F);
}

sub conv_read_medicp
{
	$sdb_mount_point="";
	$sdb_mem_flg="";
	$sdb_samplecnt="";
	open(F, $sdb_medicp_ini) || die;
	while(<F>){
		chomp;
		if(m|^MOUNTPOINT=|)
		{
			$sdb_mount_point=$';
			$sdb_mount_point =~ s/\s*,\s*/ /g;	# replace comma with space
			next;
		}
		if(m|^MEM_FLG=|)
		{
			$sdb_mem_flg=$';
			next;
		}
		if(m|^SAMPLECNT=|)
		{
			$sdb_samplecnt=$';
			next;
		}
	}
	close(F);
}

sub conv_display
{
	print "\n$msg90\n\n";
	printf "  %-26s%s\n", "$msg23", $sdb_ip;
	printf "  %-26s%s\n", "$msg92", $sdb_port;
	printf "  %-26s%s\n", "$msg25", 
		($sdb_mount_point ne "")? "$sdb_mount_point" : "$msg07";

	printf "  %-26s%s\n", "$msg26", ($sdb_mem_flg == 0)?"$msg05" :
                                      ($sdb_mem_flg == 1)?"$msg06" : $msg03;
	printf "  %-26s%s%s\n", "$msg24", $send_cycle, $msg94;

	$sdb_send_cycle="";
	if($send_cycle == 180) { $sdb_send_cycle="*/3_*_*_*_*";  }
	if($send_cycle == 300) { $sdb_send_cycle="*/5_*_*_*_*";  }
	if($send_cycle == 600) { $sdb_send_cycle="*/10_*_*_*_*"; }
	if($send_cycle == 900) { $sdb_send_cycle="*/15_*_*_*_*"; }
	if($send_cycle == 1200){ $sdb_send_cycle="*/20_*_*_*_*"; }
	if($send_cycle == 1800){ $sdb_send_cycle="*/30_*_*_*_*"; }
	if($send_cycle == 3600){ $sdb_send_cycle="0_*_*_*_*";    }
	if($sdb_send_cycle eq "")
	{
		print "$msg93\n";		# otherwise 60 minutes
		$sdb_send_cycle="0_*_*_*_*";
	}
	print "\n";
}


sub inherit_resource_setting
{
	return if(&conv_check);
	&conv_read_timer;
	&conv_read_medicp;
	&conv_display;
	if(&input_yorn($msg91))
	{
		my $r;
		my $m;
		$r = system "$ENV{HRM_bin}/sdb resource enable $sdb_ip";
		if($r != 0)
		{
			print "$msg45\n";	# failed to set IP address
			return;
		}


		$r = system "$ENV{HRM_bin}/hrmenv set period/sdbresource=$sdb_send_cycle";
		if($r != 0)
		{
			print "$msg46\n";	# failed to set cycle
			return;
		}

		foreach $m ( split(/\s+/, $resource_list ))	# current settings
		{
			next if $m eq "";
			$r = system "$ENV{HRM_bin}/sdb resource set disk.$m off";
			if($r != 0)
			{
				printf "$msg47", $m;
			}
		}

		foreach $m ( split(/\s+/, $sdb_mount_point ))  # to be set
		{
			next if $m eq "";
			$r = system "$ENV{HRM_bin}/sdb resource set disk.$m on";
			if($r != 0)
			{
				printf "$msg48", $m;
			}
		}

		if($sdb_mem_flg == 0)				# phy + vir
		{
			$r = system "$ENV{HRM_bin}/sdb resource set memory on";
			$r |= system "$ENV{HRM_bin}/sdb resource set memory_virtual on";
			if($r != 0)
			{
				printf "$msg84\n";
			}
		}elsif($sdb_mem_flg == 1)				# phy
		{
			$r = system "$ENV{HRM_bin}/sdb resource set memory on";
			$r |= system "$ENV{HRM_bin}/sdb resource set memory_virtual off";
			if($r != 0)
			{
				printf "$msg84\n";
			}
		}

		# sdb port
		$r = system "/bin/sed \"s/^sdb_port=.*/sdb_port=$sdb_port/\" $sdb_ini > $ENV{HRM_temp}/sdbini.$$";
		if($r == 0 && -f "$ENV{HRM_temp}/sdbini.$$" )
		{
			$r = system "/bin/cp -p $ENV{HRM_temp}/sdbini.$$ $sdb_ini";
			if($r == 0)
			{
				unlink "$ENV{HRM_temp}/sdbini.$$";
			}
		}
		unlink "$ENV{HRM_temp}/sdbini.$$";
		if($r != 0)
		{
			print "$msg85\n";
		}

		print "$msg49\n";
		$has_changed = 1;
	}
}


#
# main loop
#
while(1)
{
	&check_syslog;
	&check_resource;
	&check_sdb_renkei;
	&title;
	$key=<STDIN>; chomp($key);
	if($key eq '1')
	{
		&change_resource_setting;
		&press_enter;
		next;
	}
	elsif($key eq '2')
	{
		&disable_resource_setting;
		&press_enter;
		next;
	}
	elsif($key eq '3')
	{
		&inherit_resource_setting;
		&press_enter;
		next;
	}
	elsif($key eq '4')
	{
		&send_syslog_test_data;
		&press_enter;
		next;
	}
	elsif($key eq '5')
	{
		&send_resource_test_data;
		&press_enter;
		next;
	}
	elsif($key eq '6')
	{
		&change_sdb_renkei;
		&press_enter;
		next;
	}
	elsif($key eq 'q')
	{
#		if($has_changed == 1)
#		{
#			print "\n$msg78\n";
#		}

		exit(0);
	}
	else
	{
		print "invalid input data.\n";
		&press_enter;
	}
}


