#!/bin/sh 
# FJSVhrm Ulexa-HRM FUJITSU LIMITED 2004-2009
#

TITLE_PSA_RPM="===== PSA rpm check ====="
TITLE_HRM="===== HRM setup menu ====="
TITLE_PSA_STATUS="===== PSA status check ====="

MENU_ENABLE="1     enable HRM"
MENU_DISABLE="2     disable HRM"
MENU_SANENABLE="3     enable SANtool"
MENU_SANDISABLE="4     disable SANtool"
MENU_SANSETIP="5     set IP address of SANtool"
MENU_START="6     start HRM and SANtool"
MENU_STOP="7     stop HRM and SANtool"
MENU_SNMP="8     change SNMP Community name"
MENU_STATLIST_ENABLE="9     enable Statistics(MMB)"
MENU_STATLIST_DISABLE="10    disable Statistics(MMB)"
MENU_SDB_SETUP="11    SDB agent setting"
MENU_SET_PASSWORD="12    set password"
MENU_REMOVE_PASSWORD="13    remove password"
MENU_END="14    quit"

Q_SELECT_NO="Select a number [?,??,q]: "
Q_HRM_ENABLE="Do you enable the HRM [y,n?]: "
Q_HRM_DISABLE="Do you disable the HRM [y,n?]: "
Q_HRM_START="Do you start the HRM [y,n?]: "
Q_HRM_STOP="Do you stop the HRM [y,n?]: "
Q_MMB_STATISTICS_ENABLE="Do you enable the Statistics(MMB) [y,n?]: "
Q_MMB_STATISTICS_DISABLE="Do you disable the Statistics(MMB) [y,n?]: "

MSG_HRM_ENABLED="HRM was enabled."
MSG_HRM_DISABLED="HRM was disabled."
MSG_MMB_STATISTICS_ENABLED="Statistics(MMB) was enabled."
MSG_MMB_STATISTICS_DISABLED="Statistics(MMB) was disabled."

ERR_PSA_NOT_INSTALL="Error: This command can't run because PSA is not installed."
ERR_PSA_DISABLE="Error: This command can't run because PSA is not running."
ERR_HRM_RUNNING="Error: HRM is already running. Stop it at first."
ERR_HRM_DISABLE="Error: HRM is disabled. Enable it at first."
ERR_NO_ROOT="Error: This command should be run by root user."
ERR_NO_HRM_DIR="Error: Can't find HRM directory."
NOTE_MMB_IP_SUPPORT_PSA="The MMB IP Address setting is unnecessary in the PSA version being used now."

NOTE_WAIT_TIME="Note: It may take several minutes depending on the server status."


MSG_CURRENT_STATUS="current status:"
MSG_HRM_DISABLE="HRM is disabled."
MSG_HRM_ENABLE="HRM is enabled."
MSG_HRM_RUNNING=" HRM is running."
MSG_HRM_NOT_RUNNING=" HRM is not running."
MSG_MMB_STATISTICS_DISABLE="Statistics(MMB) is disabled."
MSG_MMB_STATISTICS_ENABLE="Statistics(MMB) is enabled."

ERR_COMMON_INI="Error: common.ini file is not found."
ERR_MAX_OVER_CHAR="Error:The character string is too long."
ERR_MIN_CHAR="Error: Please input the character."
ERR_MMB_IP_INPUT="Input IP address is abnormal."

Q_SNMP_NAME_UPDATE="Do you want to change the SNMP Community name? [y,n?]: "
Q_MMB_IP_UPDATE="Do you want to change the MMB IP Address? [y,n?]: "
Q_SNMP_NAME_PSA="Please input Community name for PSA communication.        :"
Q_SNMP_NAME_MMB="Please input Community name for MMB communication.        :"
Q_SNMP_NAME_SV="Please input Community name for ServerView communication. :"
Q_CHANGE_YES_NO="Do you apply the New Setting? [y,n?]: "
Q_MMB_IP="Please input MMB IP Address.             :"

MSG_CURRENT_VALUE="[Current Setting]"
MSG_NEW_VALUE="[New Setting]"
MSG_SNMP_NAME_PSA="Community name for PSA communication.        : "
MSG_SNMP_NAME_MMB="Community name for MMB communication.        : "
MSG_SNMP_NAME_SV="Community name for ServerView communication. : "
MSG_MMB_IP="MMB IP Address         : "

MSG_SNMP_NAME_UPDATE="Community name of SNMP was changed."

MSG_SANTOOL_DISABLE="SANtool is disabled."
MSG_SANTOOL_ENABLE="SANtool is enabled."
MSG_SANTOOL_RUNNING=" SANtool is running."
MSG_SANTOOL_NOT_RUNNING=" SANtool is not running."

ERR_SANTOOL_NOT_FOUND="Error: SANtool is not installed."


MSG_MMB_IP_UPDATE="MMB IP Address was changed."

MSG_NOT_SUPPORT="This feature is not supported."

Q_PASSWORD_CHANGE="You already have a password. Overwrite it [y,n?]: "
MSG_PASSWORD_HRM_REBOOT="To reflect the change, restart HRM/server."
MSG_PASSWORD_NOT_SET="Authentication password is already disabled."
Q_PASSWORD_REMOVE="Do you disable authentication password [y,n?]: "
MSG_PASSWORD_REMOVE="Authentication is disabled."
MSG_PASSWORD_ENABLED="Authentication password is enabled."
MSG_PASSWORD_DISABLED="Authentication password is disabled."

#------------------------------------------------------------
#
# determine the message file
#
base=`echo "$0" | sed "s/\.sh//"`

#------------------------------------------------------------
HRM_bin=/opt/FJSVhrm/bin
HRM_data=/var/opt/FJSVhrm/data export HRM_data
HRM_config=/var/opt/FJSVhrm/config
HRM_temp=/var/opt/FJSVhrm/temp
COMMON_INI_PATH="$HRM_config/common.ini"

PASSWD_LANG="-e"

. ${base}_func

if [ "$1" = "-j" ]; then
	if [ "$2" = "utf8" ] && [ -f "${base}.ja_JP.UTF-8" ]; then
		. ${base}.ja_JP.UTF-8
		PASSWD_LANG="-u"
	elif [ "$2" = "euc" ] && [ -f "${base}.ja_JP.eucJP" ]; then
		. ${base}.ja_JP.eucJP
		PASSWD_LANG=""
	else
		echo "usage: setup.sh [-e] [-j euc] [-j utf8]"
		exit 1
	fi
elif [ "$1" = "-e" ]; then
	:
else
	if [ "$LANG" = "ja_JP.UTF-8" ] && [ -f "${base}.ja_JP.UTF-8" ]; then
		. ${base}.ja_JP.UTF-8
		PASSWD_LANG="-u"
	elif [ "$LANG" = "ja_JP.eucJP" ] && [ -f "${base}.ja_JP.eucJP" ]; then
		. ${base}.ja_JP.eucJP
		PASSWD_LANG=""
	else
		:
	fi
fi

root_check
if [ "$?" -ne "0" ]; then
	exit 1
fi

if [ ! -d $HRM_bin ] || [ ! -d $HRM_data ] || [ ! -d $HRM_config ] || [ ! -d $HRM_temp ]; then
	echo $ERR_NO_HRM_DIR
	exit 1
fi

if [ ! -f $COMMON_INI_PATH ]; then
	echo $ERR_COMMON_INI
	exit 1
fi

rpmck=0
rpm_check
if [ "$?" -eq "0" ]; then
	rpmck=1
fi

while :
do
	echo ""
	echo "$TITLE_HRM"
	echo ""

	hrm_status
	santool_status
	password_status

	echo
	echo "$MENU_ENABLE"
	echo "$MENU_DISABLE"
	echo "$MENU_SANENABLE"
	echo "$MENU_SANDISABLE"
	echo "$MENU_SANSETIP"
	echo "$MENU_START"
	echo "$MENU_STOP"
	echo "$MENU_SNMP"
	echo "$MENU_STATLIST_ENABLE"
	echo "$MENU_STATLIST_DISABLE"
	echo "$MENU_SDB_SETUP"
	echo "$MENU_SET_PASSWORD"
	echo "$MENU_REMOVE_PASSWORD"
	echo "$MENU_END"
	echo

	while :
	do
		printf "$Q_SELECT_NO" ; read "ans"
		if [ "$ans" = "1" ] || [ "$ans" = "2" ] || [ "$ans" = "3" ] || [ "$ans" = "4" ] || [ "$ans" = "5" ] || [ "$ans" = "6" ] || [ "$ans" = "7" ] || [ "$ans" = "8" ] || [ "$ans" = "9" ] || [ "$ans" = "10" ] || [ "$ans" = "11" ] || [ "$ans" = "12" ] || [ "$ans" = "13" ] || [ "$ans" = "14" ] || [ "$ans" = "q" ] 
		then
			break
		fi
	done

	echo

	case "$ans" in 
		1) hrm_set_enable $rpmck	;;
		2) hrm_set_disable			;;
		3) santool_enable ;;            # HRM3.2 add
		4) santool_disable ;;
		5) santool_setip ;;
		6) hrm_set_start $rpmck		;;
		7) hrm_set_stop				;;
		8) update_snmp ;;
		9) statlist_update 1;;
		10) statlist_update 0;;
		11) sdb_setup $1 $2 ;;           # HRM3.4 add
		12) set_password "$PASSWD_LANG" ;;	# HRM3.5 add
		13) remove_password ;;		# HRM3.5 add
		14) exit 0 ;;
		q) exit 0 ;;
	esac

	echo "[press return]"; read a
done


